> For the complete documentation index, see [llms.txt](https://docs.commercelayer.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.commercelayer.io/rules-engine/actions/types.md).

# Types

All the types of actions currently available on the Rules Engine

At the moment, the following types of action are available (more to come — feel free to reach out to us and submit a feature request if you need specific additional types).

Check the single action type pages for more information about how they work:

<table><thead><tr><th width="239">Type</th><th width="250">Description</th><th width="145">Resources<select multiple><option value="hxfpyUUNsewy" label="Promotions" color="blue"></option><option value="3OpwB20hSpiJ" label="Price lists" color="blue"></option></select></th><th width="197" data-type="content-ref">Learn more</th></tr></thead><tbody><tr><td><strong><code>percentage</code></strong></td><td>Applies a percentage discount to the amount of the selected field.</td><td><span data-option="hxfpyUUNsewy">Promotions, </span><span data-option="3OpwB20hSpiJ">Price lists</span></td><td><a href="/rules-engine/actions/types/percentage.md">Percentage</a></td></tr><tr><td><strong><code>fixed_amount</code></strong></td><td>Applies a fixed discount to the unit amount of the selected field (or <a href="/rules-engine/actions/types/fixed-amount.md#discount-mode">proportionally distributes</a> it based on the related total amount).</td><td><span data-option="hxfpyUUNsewy">Promotions, </span><span data-option="3OpwB20hSpiJ">Price lists</span></td><td><a href="/rules-engine/actions/types/fixed-amount.md">Fixed amount</a></td></tr><tr><td><strong><code>fixed_price</code></strong></td><td>Overwrites the unit amount of the selected field with the specified value.</td><td><span data-option="hxfpyUUNsewy">Promotions, </span><span data-option="3OpwB20hSpiJ">Price lists</span></td><td><a href="/rules-engine/actions/types/fixed-price.md">Fixed price</a></td></tr><tr><td><strong><code>free_gift</code></strong></td><td>Applies a 100% discount to line items added to the cart as free gifts by targeting them by SKU, bundle, or SKU list IDs.</td><td><span data-option="hxfpyUUNsewy">Promotions</span></td><td><a href="/rules-engine/actions/types/free-gift.md">Free gift</a></td></tr><tr><td><strong><code>buy_x_pay_y</code></strong></td><td>If the quantity of the selected items is a multiple of <code>x</code>, only the same multiple of <code>y</code> units are considered for the total price computation.</td><td><span data-option="hxfpyUUNsewy">Promotions</span></td><td><a href="/rules-engine/actions/types/buy-x-pay-y.md">Buy X pay Y</a></td></tr><tr><td><strong><code>every_x_discount_y</code></strong></td><td>Applies a fixed amount discount of value <code>y</code> (proportionally distributed based on the quantity of the selected items) for each interval defined by the value <code>x</code> on the amount of a specific field.</td><td><span data-option="hxfpyUUNsewy">Promotions</span></td><td><a href="/rules-engine/actions/types/every-x-discount-y.md">Every X discount Y</a></td></tr></tbody></table>

{% hint style="warning" %}
As highlighted in the table above, not all the actions might be available for all the [Core API](https://docs.commercelayer.io/core-api-reference/) resources for which the Rules Engine is [currently enabled](/rules-engine/readme.md#core-api-integration). Check the [single resource pages](/rules-engine/resources/promotions.md) for more information.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.commercelayer.io/rules-engine/actions/types.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
